stages:
  - test
  - paper

linting:
  image: python:3.11-bullseye
  stage: test
  script:
    - cd code
    - pip install -r requirements.txt
    - isort .
    - black .
    - flake8 .
    - mypy .
  allow_failure: true
  rules:
    - changes:
        - code/*

build_paper:
  image: marvinmenzerath/latex
  stage: paper
  script:
    - cd paper
    - ./build.sh
  artifacts:
    paths:
      - paper/main.pdf
    expire_in: 1 month
  rules:
    - changes:
        - paper/*
